<?php
/**
 * @copyright 2016 Talldude Networks, LLC.
 */

// make sure we are not being called directly
defined('APP_DIR') or exit();

/**
 * meta
 */
function jrFriend_meta(){
    $_tmp = array(
        'name'        => 'Followers to Friends',
        'url'         => 'followers-to-friends',
        'version'     => '0.0.1',
        'developer'   => 'The Jamroom Network, ©' . strftime('%Y'),
        'description' => 'A listener module. Upon follower acceptence, it reciprocates the follow.',
        'category'    => 'custom',
        'requires'    => 'jrFollower',
        'license'     => 'jcl'
    );
    return $_tmp;
}

/**
 * init
 */
function jrFriend_init(){
    // Update Item listener
    jrCore_register_event_listener('jrCore', 'db_update_item', 'jrFriend_db_update_item_listener');

    // Create Item listener
    jrCore_register_event_listener('jrCore', 'db_create_item', 'jrFriend_db_create_item_listener');

    // Register our friend tools
    jrCore_register_module_feature('jrCore', 'tool_view', 'jrFriend', 'approve_set', array('Set Approval', 'Set all site profiles to \'Follower Approve\''));

    return true;
}

//----------------------
// EVENT LISTENERS
//----------------------

/**
 * Update item listener
 * @param $_data array incoming data array of item including original owner profile and user IDs
 * @param $_user array current user info
 * @param $_conf array Global config
 * @param $_args array of new owner profile and user IDs
 * @param $event string Event Trigger name
 * @return array
 */
function jrFriend_db_update_item_listener($_data, $_user, $_conf, $_args, $event){
    if ($_args['module'] == 'jrFollower' && jrCore_checktype($_args['_item_id'], 'number_nz') && isset($_data['follow_active']) && $_data['follow_active'] == 1) {
        // Its a follow accept - Let's reciprocate
        $_rt = jrCore_db_get_item('jrFollower', $_args['_item_id'], true);
        $_tmp = array(
            'follow_active'     => 1,
            'follow_profile_id' => $_rt['_profile_id']
        );
        jrCore_db_create_item('jrFollower', $_tmp);
    }
    return $_data;
}

/**
 * Create item listener
 * @param $_data array incoming data array of item including original owner profile and user IDs
 * @param $_user array current user info
 * @param $_conf array Global config
 * @param $_args array of new owner profile and user IDs
 * @param $event string Event Trigger name
 * @return array
 */
function jrFriend_db_create_item_listener($_data, $_user, $_conf, $_args, $event){
    if ($_args['module'] == 'jrProfile' && jrCore_checktype($_args['_item_id'], 'number_nz')) {
        // Its a profile creation - set follower approve to 'on'
        $_data['profile_jrFollower_approve'] = 'on';
    }
    return $_data;
}