<?php
/**
 * @copyright 2016 Talldude Networks, LLC.
 */

// make sure we are not being called directly
defined('APP_DIR') or exit();

//------------------------------
// approve_set
//------------------------------
function view_jrFriend_approve_set($_post, &$_user, &$_conf){
    jrUser_master_only();
    jrCore_page_include_admin_menu();
    jrCore_page_admin_tabs('jrFriend');
    jrCore_page_banner('Set Follower Approval');

    // Form init
    $_tmp = array(
        'submit_value'  => 'Set Approvals',
        'cancel'        => "{$_conf['jrCore_base_url']}/{$_post['module_url']}/admin/tools",
        'submit_prompt' => 'Are you sure you want to set all your profiles to Follower Approve?',
        'submit_modal'  => 'update',
        'modal_width'   => 800,
        'modal_height'  => 400,
        'modal_note'    => 'Please be patient whilst group discussions are alternatively imported'
    );
    jrCore_form_create($_tmp);

    $_tmp = array(
        'name'     => 'dummy',
        'value'  => 'off',
        'type'     => 'hidden'
    );
    jrCore_form_field_create($_tmp);

    jrCore_page_display();
}

//------------------------------
// approve_set
//------------------------------
function view_jrFriend_approve_set_save($_post, &$_user, &$_conf){
    jrUser_master_only();
    jrCore_form_validate($_post);

    // How many profiles are in the system?
    $pcnt = jrCore_db_get_datastore_item_count('jrProfile');
    jrCore_form_modal_notice('update', "Setting {$pcnt} profiles to 'Follower Approve'");
    // Get all their IDs
    $_s = array(
        'return_item_id_only' => true,
        'limit'       => $pcnt
    );
    $_rt = jrCore_db_search_items('jrProfile', $_s);
    if ($_rt && is_array($_rt) && count($_rt) > 0) {
        $_tmp = array();
        foreach ($_rt as $rt) {
            $_tmp["{$rt}"] = array('profile_jrFollower_approve' => 'on');
        }
        jrCore_db_update_multiple_items('jrProfile', $_tmp);
    }
    else {
        jrCore_form_modal_notice('update', "Error: Profiles not found");
    }
    jrCore_form_modal_notice('complete', "Done");
    jrCore_form_result();
}